{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
uses spacep;

const txtsize=2308; { a szveg hossza }
{ Ezt az rtket mindig utna kell mdostani, ha vltozik a szveg !!}

const centrex=100; centrey=100;
      maxpt=216;   maxpl=54;
      maxx=200;
      c_x0=204;    c_y0=4;
      c_x1=260;    c_y1=5;
      c_x2=216;    c_y2=2;
      c_x3=208;    c_y3=190;
      c_x4=259;    c_y4=25;
      radius=10;
      starttime='u';
      contrast:byte=16;
      msens:integer=8;
      timecolc:byte=0;
      timecol:byte=2; timecolh:byte=2;
      edge_grad=45;   rotstep:integer=5; rotstep2:integer=5;
      jcdef:integer=18;
      maxjob=20;
      maxkeys=28;

      fcnt:longint=0;
      anti:integer=1;
      auto:integer=0;
      wvron:integer=1;
      scroll:integer=1;
      recording:byte=0;
      recordfull:byte=0;
      recordidx:byte=0;
      rot:byte=0;
      sctext:string[32]='';
      scstep:byte=0;
      sccol:byte=2;
      sclen=12;
      rotcmax=4;

      rotconst:array[0..rotcmax-1,0..1] of integer=((5,18),(10,9),(30,3),(1,90));
type tkeys=array[0..maxkeys] of byte;
const
      defkeys:tkeys=
        (16,17,18,30,31,32,21,34,47,22,35,48,51,52,82,83,73,71,79,81,12,13,14,
        72,80,75,77,44,45);
      keys:tkeys=
        (16,17,18,30,31,32,21,34,47,22,35,48,51,52,82,83,73,71,79,81,12,13,14,
        72,80,75,77,44,45);
      tl1='dlaldlla';
      tl2='ficifiic';
      h1='dficlaiifllc';
      h2='fdlaiclldiia';
      lat:array[0..3] of integer=(0,4,3,1);

type
     t4=array[0..3] of longint;
     t4i=array[0..3] of integer;
     t33=array[0..2,0..2] of integer;
     t3=array[0..2] of integer;

var buff,screen,txt:pointer;
    font,pic,mpic:pointer;
    txtp:^char;
    c_contrast:real;
    kbuff:string;
    cube:array[0..5] of t33;
    t:longint absolute $40:$6c;
    time1,time2,timel:longint;
    mon,mt,mico,mx,my,mox,moy,mb,mob:integer;
    lst,selface:integer;
    ar:array[0..3] of integer;

type p3d=record
            x,y,z:real;
         end;
     p2d=record
            x,y,c:integer;
         end;
var
      point2:array[0..maxpt] of p2d;
      rc,point3:array[0..maxpt] of p3d;
      planes:array[0..maxpl,0..5] of integer;
      plord:array[0..maxpl-1,0..1] of integer;
      plonr:integer;
      zoom,csa,sna:real;
      csax,csay,csaz,snax,snay,snaz:real;
      ptnr,plnr:integer;
      zbarp:integer;
      fc:array[0..5] of byte;

const plid:array[0..5,0..3] of integer=
      ((2,0,4,6),(2,3,1,0),(7,3,2,6),(3,7,5,1),(7,6,4,5),(0,1,5,4));
      cfaces:array[0..5] of byte=(0,1,2,3,4,5);
      prejobs:array[0..9] of string[31]=(
      'mm','leib','','','','','','','','');

const
      rot_x:integer=15;
      rot_y:integer=-15;
      rot_z:integer=0;
      job:integer=-1;
      jobcount:integer=0;

procedure RubikTxt;external;
{$L text.obj}

{$I init.pas}
{$I buff.pas}
{$I poly.pas}
type pint=^integer;
     pchr=^byte;

procedure putpixel(x,y,col:integer);assembler;
asm
     les di,buff
     mov ax,x
     cmp ax,320
     jae @@out
     add di,ax
     mov ax,y
     cmp ax,200
     jae @@out
     shl ax,6
     add di,ax
     shl ax,2
     add di,ax
     mov ax,col
     stosb
@@out:
end;

procedure putm(x,y,n:integer);
var p:^byte;
    i,j:integer;
    b:byte;
begin
   p:=mpic;
   asm
    mov ax,n
    shl ax,8
    add word ptr [p],ax
   end;
   for i:=0 to 15 do
      for j:=0 to 15 do
        begin
          b:=p^;
          if b<>0 then putpixel(x+j,y+i,b);
          asm
            inc word ptr [p]
          end;
        end;
end;

procedure putline(x1,x2,y,col:integer);assembler;
asm
     les di,buff
     mov cx,x2
     sub cx,x1
     inc cx
     add di,x1
     mov ax,y
     shl ax,6
     add di,ax
     shl ax,2
     add di,ax
     mov ax,col
     rep stosb
end;

procedure putchar(x,y,char,col:integer);assembler;
asm
    push ds
    les di,buff
    lds si,font
    add di,x
    mov ax,y
    shl ax,6
    add di,ax
    shl ax,2
    add di,ax
    mov ax,char
    shl ax,3
    add si,ax
    mov ax,col
    mov dx,8
@@loop1:
    mov cx,8
    mov bl,ds:[si]
    inc si
@@loop2:
    test bl,80h
    je @@skip
    mov es:[di],al
@@skip:
    inc di
    shl bl,1
    loop @@loop2
    add di,320-8
    dec dx
    jne @@loop1
    pop ds
end;

procedure putstring(x,y:integer;s:string;col:integer);
var i:integer;
begin
  if(byte(s[0])>0) then for i:=1 to byte(s[0]) do
    putchar(x+i*8-8,y,byte(s[i]),col);
end;

procedure putchar2(x,y,char,col:integer);assembler;
asm
    push ds
    les di,pic
    lds si,font
    add di,x
    mov ax,y
    shl ax,6
    add di,ax
    shl ax,2
    add di,ax
    mov ax,char
    shl ax,3
    add si,ax
    mov ax,col
    mov dx,8
@@loop1:
    cmp di,320*192
    jae @@out
    mov cx,8
    mov bl,ds:[si]
    inc si
@@loop2:
    test bl,80h
    je @@skip
    mov es:[di],al
@@skip:
    inc di
    shl bl,1
    loop @@loop2
    add di,320-8
    dec dx
    jne @@loop1
@@out:
    pop ds
end;

procedure putstring2(x,y:integer;s:string;col:integer);
var i:integer;
begin
  if(byte(s[0])>0) then for i:=1 to byte(s[0]) do
    putchar2(x+i*8-8,y,byte(s[i]),col);
end;

procedure puttime2(x,y:integer;time2:longint);
var s,ss:string;
    h,m,sc:integer;
begin
    sc:=time2 mod 60;
    time2:=time2 div 60;
    m:=time2 mod 60;
    time2:=time2 div 60;
    h:=time2;
    str(sc,ss);if byte(ss[0])=1 then ss:='0'+ss;
    str(m,s);if byte(s[0])=1 then s:='0'+s;
    s:=s+':'+ss;
    str(h,ss);if byte(ss[0])=2 then ss:=ss[2];
    s:=ss+':'+s;
    putstring(x,y,s,sccol);
end;

procedure puttime(x,y:integer);
var s,ss:string;
    h,m,sc:integer;
begin
    time2:=round((t-time1)/18.2);
    puttime2(x,y,time2);
end;


procedure polya(x,y:array of integer;col,nr:integer);
var i,j,k,lp,rp,ln,rn,ls,rs,ols,ors:integer;
    lx,rx,li,ri,dx,dy:longint;
    miny,maxy,minp,first:integer;
    colh,coll:byte;
begin
    colh:=col and $e0;
    coll:=col and $1f;
    miny:=y[0];maxy:=y[0];minp:=0;first:=2;
    for i:=1 to nr-1 do begin
      if y[i]<miny then begin miny:=y[i];minp:=i;end;
      if y[i]>maxy then maxy:=y[i];
      end;
    lp:=minp;rp:=minp;lx:=longint(X[lp]) shl 16;rx:=longint(x[rp])shl 16;
    ols:=lx shr 16;
    ors:=rx shr 16;
    for i:=miny to maxy do begin
      while (i=y[lp]) or (first=2) do begin
        if first=2 then first:=1;
        ln:=lp+1;if (ln>=nr) then ln:=0;
        dy:=y[ln]-y[lp];dx:=x[ln]-x[lp];
        lx:=longint(x[lp])shl 16;
        if (dy<>0) then li:=(dx shl 16)div dy else li:=0;
        lp:=ln;
        if (lp=minp) then break;
        end;
      while (i=y[rp]) or (first=1) do begin
        first:=0;
        rn:=rp-1;if (rn=-1) then rn:=nr-1;
        dy:=y[rn]-y[rp];dx:=x[rn]-x[rp];
        rx:=longint(x[rp])shl 16;
        if (dy<>0) then ri:=(dx shl 16)div dy else ri:=0;
        rp:=rn;
        if (rp=minp) then break;
        end;
      asm
       db 66h; mov ax,word ptr [lx]
       db 66h; sar ax,16
       dec ax
       mov ls,ax
       mov bx,ax

       db 66h; mov ax,word ptr [rx]
       db 66h; sar ax,16
       inc ax
       mov rs,ax

       cmp word ptr i,200
       jae @@out
       cmp ax,bx
       jle @@startline
       sub ax,bx
       cmp ax,2
       jg @@out

       mov ax,word ptr [lx]
       sub ax,word ptr [rx]
       mov cl,coll
       xor ch,ch
       mul cx
       add dl,colh
       les di,buff
       add di,bx
       mov ax,i
       shl ax,6
       add di,ax
       shl ax,2
       add di,ax
       mov es:[di],dl

       jmp @@out
@@startline:

       push ax
       push bx
       push word ptr [i]
       push word ptr [col]
       call putline

@@anti1:
       mov ax,word ptr [li+2]
       cmp ax,0
       jge @@skipl
       neg ax
@@skipl:
       cmp ax,1
       jg @@outl
       mov ax,ols
       sub ax,ls
       jns @@skipl2
       neg ax
@@skipl2:
       cmp ax,1
       jg @@outl

       mov ax,word ptr lx
       mov bl,coll
       xor bh,bh
       mul bx
       and dx,1fh
       mov bx,col
       sub bl,coll
       add bx,dx
       mov ax,ls
       inc ax
       push ax
       push i
       push bx
       call putpixel
       jmp @@nextl

@@outl:
       mov bx,ls
       mov cx,ols
       cmp bx,cx
       jle @@skip1l
       xchg bx,cx
@@skip1l:
       sub cx,bx
       jz @@nextl
       inc cx
       mov al,coll     { colorcount }
       shl ax,8
       xor dx,dx
       div cx
       mov dx,ax       { increment  }
       les di,buff
       add di,bx
       mov ax,i
       shl ax,6
       add di,ax
       shl ax,2
       add di,ax
       mov ah,byte ptr [col]
       xor al,al
       inc di
@@loopl:
       mov es:[di],ah
       inc di
       sub ax,dx
       loop @@loopl

@@nextl:
       mov ax,word ptr [ri+2]
       cmp ax,0
       jge @@skipr
       neg ax
@@skipr:
       cmp ax,1
       jg @@outr
       mov ax,ors
       sub ax,rs
       jns @@skipr2
       neg ax
@@skipr2:
       cmp ax,1
       jg @@outr

       mov ax,word ptr rx
       mov bl,coll
       xor bh,bh
       mul bx
       and dx,1fh
       mov bx,col
       sub bx,dx
       mov ax,rs
       dec ax
       push ax
       push i
       push bx
       call putpixel
       jmp @@nextr
@@outr:
       mov bx,rs
       mov cx,ors
       cmp bx,cx
       jle @@skip1r
       xchg bx,cx
@@skip1r:
       sub cx,bx
       jz @@nextr
       inc cx
       mov al,coll     { colorcount }
       shl ax,8
       xor dx,dx
       div cx
       mov dx,ax       { increment  }
       les di,buff
       add di,bx
       mov ax,i
       shl ax,6
       add di,ax
       shl ax,2
       add di,ax
       mov ah,byte ptr [colh]
       xor al,al
       dec di
@@loopr:
       add ax,dx
       mov es:[di],ah
       inc di
       loop @@loopr

@@nextr:
@@out:
       db 66h; mov ax,word ptr [li]
       db 66h; add word ptr [lx],ax
       db 66h; mov ax,word ptr [ri]
       db 66h; add word ptr [rx],ax
      end;
      ols:=ls;ors:=rs;
    end;
end;

procedure polyn(x,y:array of integer;col,nr:integer);
var i,j,k,lp,rp,ln,rn,ls,rs:integer;
    lx,rx,li,ri,dx,dy:longint;
    miny,maxy,minp,first:integer;
begin
    miny:=y[0];maxy:=y[0];minp:=0;first:=2;
    for i:=1 to nr-1 do begin
      if y[i]<miny then begin miny:=y[i];minp:=i;end;
      if y[i]>maxy then maxy:=y[i];
      end;
    lp:=minp;rp:=minp;lx:=longint(X[lp]) shl 16;rx:=longint(x[rp])shl 16;
    for i:=miny to maxy do begin
      while (i=y[lp]) or (first=2) do begin
        if first=2 then first:=1;
        ln:=lp+1;if (ln>=nr) then ln:=0;
        dy:=y[ln]-y[lp];dx:=x[ln]-x[lp];
        lx:=longint(x[lp])shl 16;
        if (dy<>0) then li:=(dx shl 16)div dy else li:=0;
        lp:=ln;
        if (lp=minp) then break;
        end;
      while (i=y[rp]) or (first=1) do begin
        first:=0;
        rn:=rp-1;if (rn=-1) then rn:=nr-1;
        dy:=y[rn]-y[rp];dx:=x[rn]-x[rp];
        rx:=longint(x[rp])shl 16;
        if (dy<>0) then ri:=(dx shl 16)div dy else ri:=0;
        rp:=rn;
        if (rp=minp) then break;
        end;
      asm
       db 66h; mov ax,word ptr [lx]
       db 66h; sar ax,16
       mov ls,ax
       mov bx,ax

       db 66h; mov ax,word ptr [rx]
       db 66h; sar ax,16
       mov rs,ax
       cmp ax,bx
       jg @@out
       cmp word ptr i,200
       jae @@out

       push ax
       push bx
       push word ptr [i]
       push word ptr [col]
       call putline
@@out:
       db 66h; mov ax,word ptr [li]
       db 66h; add word ptr [lx],ax
       db 66h; mov ax,word ptr [ri]
       db 66h; add word ptr [rx],ax
      end;
    end;
end;

procedure init;
var i:integer;
begin
  randomize;
  asm mov ax,13h; int 10h; end; screen:=ptr(sega000,0);
  total:=5;
  setinfodat(0,'rubik.pcx');
  setinfodat(1,'rubik.mac');
  setinfodat(2,'arrows.cel');
  setinfodat(3,'rubik.key');
  getmem(pic,64000);
  getmem(buff,64000);
  getmem(mpic,800+16*144);
  txt:=@RubikTxt;
  txtp:=txt;
  loadpcx(0,pic,true);
  loaddata(1,addr(prejobs));
  loaddata(2,mpic);
  loaddata(3,addr(keys));
  asm
    add word ptr [mpic],800
  end;
  initpoints;
  mx:=160;mox:=mx;
  my:=100;moy:=my;
  mb:=0;mob:=mb;mico:=0;mt:=0;
  asm
    push bp
    mov ax,1130h
    mov bh,3
    int 10h
    mov word ptr [font],bp
    mov word ptr [font+2],es
    pop bp
    mov ax,0
    int 33h
    mov ax,2
    int 33h
  end;
end;

procedure done;
var f:file;
begin
    asm
      mov ax,3
      int 10h
      sub word ptr [mpic],800
    end;
    freemem(buff,64000);
    freemem(pic,64000);
    freemem(mpic,800+16*144);
    getfileposition(3,f);blockwrite(f,keys,maxkeys+1);close(f);
    getfileposition(1,f);blockwrite(f,prejobs,320);close(f);
    donespace;
end;

function getcubestat:integer;
var i,j,k,s:integer;
begin
    getcubestat:=0;
    for i:=0 to 5 do
      fc[i]:=cube[i][1,1];
    k:=0;
    for i:=0 to 2 do
      for j:=0 to 2 do
        if cube[5][i,j]=fc[5] then inc(k);
    if k<9 then exit;
    k:=0;
    for i:=1 to 2 do
      begin
        if cube[0][0,i]=cube[0][0,0] then inc(k);
        if cube[1][0,i]=cube[1][0,0] then inc(k);
        if cube[3][0,i]=cube[3][0,0] then inc(k);
        if cube[4][0,i]=cube[4][0,0] then inc(k);
      end;
    if k<8 then exit;
    getcubestat:=1;
    if cube[0][0,0]<>fc[0] then exit;
    k:=0;
    for i:=0 to 2 do
      begin
        if cube[0][1,i]=fc[0] then inc(k);
        if cube[1][1,i]=fc[1] then inc(k);
        if cube[3][1,i]=fc[3] then inc(k);
        if cube[4][1,i]=fc[4] then inc(k);
      end;
    if k<12 then exit;
    getcubestat:=2;
    k:=0;
    if cube[2][0,1]=fc[2] then inc(k);
    if cube[2][1,0]=fc[2] then inc(k);
    if cube[2][1,2]=fc[2] then inc(k);
    if cube[2][2,1]=fc[2] then inc(k);
    if k<4 then exit;
    getcubestat:=3;
    k:=0;
    if cube[0][2,1]=fc[0] then inc(k);
    if cube[1][2,1]=fc[1] then inc(k);
    if cube[3][2,1]=fc[3] then inc(k);
    if cube[4][2,1]=fc[4] then inc(k);
    s:=3;
    if k=4 then inc(s);
    k:=0;
    if cube[0][2,0]=fc[0] then inc(k);
    if cube[1][2,0]=fc[1] then inc(k);
    if cube[3][2,0]=fc[3] then inc(k);
    if cube[4][2,0]=fc[4] then inc(k);
    if cube[0][2,2]=fc[0] then inc(k);
    if cube[1][2,2]=fc[1] then inc(k);
    if cube[3][2,2]=fc[3] then inc(k);
    if cube[4][2,2]=fc[4] then inc(k);
    if k=8 then inc(s);
    getcubestat:=s;
end;

procedure scrollpic;assembler;
asm
   push ds
   les di,pic
   lds si,pic
   add di,208+56*320
   add si,208+57*320
   cld
   mov dx,135
@@loop1:
   mov cx,104/4
   db 66h; rep movsw
   add di,320-104
   add si,320-104
   dec dx
   jne @@loop1
   db 66h; xor ax,ax
   mov cx,104/4
   db 66h; rep stosw
   pop ds
end;

function gettxtchar:char;
var c:char;
begin
   gettxtchar:=txtp^;
   if txtp^=#26 then txtp:=txt else begin
      inc(longint(txtp));
      if longint(txtp)>=longint(txt)+txtsize
        then txtp:=txt;
      end;
end;

function gettxtline:string;
var s:string;i:integer;c:char;
begin
    s:='';i:=0;repeat
      c:=gettxtchar;
      if not (c in [#13,#10,#26]) then begin
        s:=s+c;inc(i);
        if i>sclen then if txtp^=#13 then
          gettxtchar;
        end;
    until (i>sclen) or (c in[#13,#26]);
    gettxtline:=s;
end;

procedure puttxtline;
var h:integer;
begin
   h:=timecol;
   if h>=16 then h:=31-h;timecolc:=timecolh*32+80+h;
   scrollpic;
   putstring2(c_x3,c_y3-scstep,sctext,timecolc);
   inc(scstep);if scstep=8 then begin
      scstep:=0;
      sctext:=gettxtline;
      timecol:=(timecol+1) mod 32;
    end;
end;

procedure rot33l(var f:t33);
var t:integer;
begin
    t:=f[0,1];
    f[0,1]:=f[0,2];f[0,2]:=f[1,2];f[1,2]:=f[2,2];
    f[2,2]:=f[2,1];f[2,1]:=f[2,0];f[2,0]:=f[1,0];
    f[1,0]:=f[0,0];f[0,0]:=t;
end;

procedure rot33r(var f:t33);
var t:integer;
begin
    t:=f[0,1];
    f[0,1]:=f[0,0];f[0,0]:=f[1,0];f[1,0]:=f[2,0];
    f[2,0]:=f[2,1];f[2,1]:=f[2,2];f[2,2]:=f[1,2];
    f[1,2]:=f[0,2];f[0,2]:=t;
end;

procedure get3h(var l:t3;var t:t33;j:integer);
var i:integer;
begin
  for i:=0 to 2 do
    l[i]:=t[j,i];
end;

procedure get3v(var l:t3;var t:t33;j:integer);
var i:integer;
begin
  for i:=0 to 2 do
    l[i]:=t[i,j];
end;

procedure put3h(var l:t3;var t:t33;j:integer);
var i:integer;
begin
  for i:=0 to 2 do
    t[j,i]:=l[i];
end;

procedure put3v(var l:t3;var t:t33;j:integer);
var i:integer;
begin
  for i:=0 to 2 do
    t[i,j]:=l[i];
end;

procedure put3hr(var l:t3;var t:t33;j:integer);
var i:integer;
begin
  for i:=0 to 2 do
    t[j,i]:=l[2-i];
end;

procedure put3vr(var l:t3;var t:t33;j:integer);
var i:integer;
begin
  for i:=0 to 2 do
    t[i,j]:=l[2-i];
end;

procedure buildcube;
var i,j:integer;
    xx,yy,zz:integer;
begin
    for i:=0 to plnr-1 do
      begin
        xx:=0;yy:=0;zz:=0;
        for j:=0 to 3 do
          begin
            xx:=xx+round(rc[planes[i][j]].x);
            yy:=yy+round(rc[planes[i][j]].y);
            zz:=zz+round(rc[planes[i][j]].z);
          end;
        xx:=xx div 4;
        yy:=yy div 4;
        zz:=zz div 4;
        if (xx=-29) then cube[1][(yy +20) div 20,2-(zz +20) div 20]:=planes[i][4];
        if (xx=29) then cube[4][(yy +20) div 20,(zz +20) div 20]:=planes[i][4];
        if (yy=-29) then cube[5][2-(zz +20) div 20,(xx +20) div 20]:=planes[i][4];
        if (yy=29) then cube[2][(zz +20) div 20,(xx +20) div 20]:=planes[i][4];
        if (zz=-29) then cube[0][(yy +20) div 20,(xx +20) div 20]:=planes[i][4];
        if (zz=29) then cube[3][(yy +20) div 20,2-(xx +20) div 20]:=planes[i][4];
      end;
end;

procedure rotfz(d:integer);
var t:byte;
begin
  t:=cfaces[1];
  case d of
    -1:begin
         cfaces[1]:=cfaces[5];
         cfaces[5]:=cfaces[4];
         cfaces[4]:=cfaces[2];
         cfaces[2]:=t;
       end;
    1:begin
         cfaces[1]:=cfaces[2];
         cfaces[2]:=cfaces[4];
         cfaces[4]:=cfaces[5];
         cfaces[5]:=t;
       end;
    end;
end;

procedure rotfy(d:integer);
var t:byte;
begin
  t:=cfaces[0];
  case d of
    -1:begin
         cfaces[0]:=cfaces[4];
         cfaces[4]:=cfaces[3];
         cfaces[3]:=cfaces[1];
         cfaces[1]:=t;
       end;
    1:begin
         cfaces[0]:=cfaces[1];
         cfaces[1]:=cfaces[3];
         cfaces[3]:=cfaces[4];
         cfaces[4]:=t;
       end;
    end;
end;

procedure rotfx(d:integer);
var t:byte;
begin
  t:=cfaces[0];
  case d of
    1:begin
         cfaces[0]:=cfaces[5];
         cfaces[5]:=cfaces[3];
         cfaces[3]:=cfaces[2];
         cfaces[2]:=t;
       end;
    -1:begin
         cfaces[0]:=cfaces[2];
         cfaces[2]:=cfaces[3];
         cfaces[3]:=cfaces[5];
         cfaces[5]:=t;
       end;
    end;
end;

procedure rotz2(var p:p3d);
var pp:p3d;
begin
    pp:=p;
    with pp do begin
      p.x:=(x*csa-y*sna);
      p.y:=(x*sna+y*csa);
    end;
end;

procedure roty2(var p:p3d);
var pp:p3d;
begin
    pp:=p;
    with pp do begin
      p.z:=(z*csa-x*sna);
      p.x:=(z*sna+x*csa);
    end;
end;

procedure rotx2(var p:p3d);
var pp:p3d;
begin
    pp:=p;
    with pp do begin
      p.y:=(y*csa-z*sna);
      p.z:=(y*sna+z*csa);
    end;
end;

function sign(t:integer):integer;
begin
  if t=0 then sign:=0 else if t<0 then sign:=-1 else sign:=1;
end;

var a,b:t3;

procedure rotallz(t,min,max:integer);
var i:integer;
begin
    csa:=cos(pi/180*t);
    sna:=sin(pi/180*t);
    if jobcount=1 then if (min<0) and (max>0) then
      rotfz(sign(t));
    for i:=0 to ptnr do
      with rc[i] do
        if (z>min) and (z<max) then
           rotz2(rc[i]);
end;

procedure rotally(t,min,max:integer);
var i:integer;
begin
    csa:=cos(pi/180*t);
    sna:=sin(pi/180*t);
    if jobcount=1 then if (min<0) and (max>0) then
      rotfy(-sign(t));
    for i:=0 to ptnr do
      with rc[i] do
        if (y>min) and (y<max) then
           roty2(rc[i]);
end;

procedure rotallx(t,min,max:integer);
var i:integer;
begin
    csa:=cos(pi/180*t);
    sna:=sin(pi/180*t);
    if jobcount=1 then if (min<0) and (max>0) then
      rotfx(sign(t));
    for i:=0 to ptnr do
      with rc[i] do
        if (x>min) and (x<max) then
           rotx2(rc[i]);
end;

procedure rotz(var p:p3d);
var pp:p3d;
begin
    pp:=p;
    with pp do begin
      p.x:=x*csaz-y*snaz;
      p.y:=x*snaz+y*csaz;
    end;
end;

procedure roty(var p:p3d);
var pp:p3d;
begin
    pp:=p;
    with pp do begin
      p.z:=z*csay-x*snay;
      p.x:=z*snay+x*csay;
    end;
end;

procedure rotx(var p:p3d);
var pp:p3d;
begin
    pp:=p;
    with pp do begin
      p.y:=y*csax-z*snax;
      p.z:=y*snax+z*csax;
    end;
end;

procedure proj;
var i:integer;
begin
    for i:=0 to ptnr-1 do begin
       point2[i].x:=round(point3[i].x*zoom);
       point2[i].y:=round(point3[i].y*zoom);
    end;
end;

procedure roundrc;
var i:integer;
begin
  for i:=0 to ptnr do
     with rc[i] do begin
       x:=round(x);
       y:=round(y);
       z:=round(z);
     end;
  buildcube;
end;

procedure addplord(n,z:integer);
var i,j:integer;
begin
    if plonr=0 then begin
        plord[plonr,0]:=n;
        plord[plonr,1]:=z;
       end else
    if plord[plonr-1,1]<=z then begin
        plord[plonr,0]:=n;
        plord[plonr,1]:=z;
       end else
    begin
       i:=0;
       while plord[i,1]<z do
         inc(i);
       for j:=plonr downto i do
         plord[j+1]:=plord[j];
       plord[i,0]:=n;
       plord[i,1]:=z;
    end;
    inc(plonr);
end;

procedure makeplane(n:integer);
var x,y:t4i;
    cc,i:integer;
    a1,a2,b1,b2,r:real;
    xx,yy,z:real;
    zz:integer;
begin
    a1:=point2[planes[n,0]].x-point2[planes[n,1]].x;
    b1:=point2[planes[n,0]].y-point2[planes[n,1]].y;
    a2:=point2[planes[n,1]].x-point2[planes[n,2]].x;
    b2:=point2[planes[n,1]].y-point2[planes[n,2]].y;
    r:=a1*b2-a2*b1;
    if r<=0 then exit;
    i:=(32-contrast)+round(r*contrast/1210);
    if i>31 then i:=31;
    planes[n,5]:=i;
    z:=0;zz:=0;xx:=0;yy:=0;
    for i:=0 to 3 do
      begin
        z:=z+point3[planes[n,i]].z;
        zz:=zz+round(rc[planes[n,i]].z);
        xx:=xx+point2[planes[n,i]].x;
        yy:=yy+point2[planes[n,i]].y;
      end;
    addplord(n,round(z));
    if mico=0 then
    if zz=-29*4 then begin
      xx:=xx/4;yy:=yy/4;
      xx:=sqr(xx-mx+centrex);
      yy:=sqr(yy-my+centrey);
      r:=sqr(radius*zoom);
      if xx+yy<r then begin
        selface:=n;
        planes[n,5]:=15;
        end;
    end;
end;

procedure drawplane(n:integer);
var x,y:t4i;
    cc,i:integer;
    a1,a2,b1,b2,r:real;
begin
    n:=plord[n,0];
    for i:=0 to 3 do
      begin
        x[i]:=point2[planes[n,i]].x+centrex;
        y[i]:=point2[planes[n,i]].y+centrey;
      end;
{    cc:=planes[n,4]*32+80;}
    cc:=planes[n,4]*32+64+planes[n,5];
    if anti=1 then polya(x,y,cc,4)
              else polyn(x,y,cc,4)
end;

function keypressed:boolean;
begin
   keypressed:=memw[$40:$1a] <> memw[$40:$1c];
end;

procedure rotate;
var i:integer;
begin
    csax:=cos(rot_x*pi/180);
    snax:=sin(rot_x*pi/180);
    csay:=cos(rot_y*pi/180);
    snay:=sin(rot_y*pi/180);
    csaz:=cos(rot_z*pi/180);
    snaz:=sin(rot_z*pi/180);
     for i:=0 to ptnr-1 do
       begin
         roty(point3[i]);
         rotz(point3[i]);
         rotx(point3[i]);
       end;
end;

procedure addbuff(i:integer);
var k:integer;
begin
  if recording=1 then begin
    if recordfull=1 then exit;
    prejobs[recordidx]:=prejobs[recordidx]+char(97+i);
    k:=byte(prejobs[recordidx][0]);
    if k>=31 then begin recordfull:=1;exit;end;
  end;
end;

procedure addjob(i,j:integer);
begin
  job:=i;jobcount:=j;
  addbuff(i);
end;

procedure randbuff;
var i:integer;
begin
  kbuff:='';
  for i:=0 to 127 do
    kbuff:=kbuff+char(97+random(maxjob));
  kbuff:=kbuff+starttime;
end;

procedure randbuff1;
var i:integer;
begin
  kbuff:='';
  kbuff:=kbuff+char(97+random(maxjob));
end;

function searchkey(k1:byte):integer;
var i:integer;
begin
    searchkey:=-1;
    for i:=0 to maxkeys do
      if keys[i]=k1 then searchkey:=i;
end;

procedure stopmacro;
begin
   recording:=0;
end;

procedure recordmacro;
var k:integer;
begin
   if recording=1 then begin stopmacro; exit;end;
   putstring(0,0,'Which macro (0 - 9) ?',sccol);movp;
   asm mov ax,0; int 16h; mov k,ax;end;
   k:=hi(k)-2;
   if (k<0) or (k>=10) then begin
        putstring(0,8,'Invalid key !',sccol);
        putstring(0,16,'Press any key !',sccol);movp;
        asm mov ax,0; int 16h; mov k,ax;end;
        exit;
      end;
   prejobs[k]:='';
   recordidx:=k;
   recordfull:=0;
   recording:=1;
end;


procedure redefinekeys;
var i,j,l,k:integer;
    k1,k2:byte;
begin
    putstring(0,0,'Press the key you want to',sccol);
    putstring(0,8,'Change',sccol);movp;
    asm mov ax,0; int 16h; mov k,ax;end;
    k1:=hi(k);j:=searchkey(k1);
    if j=-1 then begin
        putstring(0,16,'No key found !',sccol);
        putstring(0,24,'Press any key !',sccol);movp;
        asm mov ax,0; int 16h; mov k,ax;end;
        exit;
      end;
    putstring(0,16,'Enter new key',sccol);movp;
    asm mov ax,0; int 16h; mov k,ax;end;
    k2:=hi(k);l:=searchkey(k2);
    if ((l<>-1) and (j<>l)) or (k2=1) or (k2=41) or ((k2>=2) and (k2<=11)) or ((k2>=59) and (k2<=68)) then begin
        putstring(0,24,'You can''t use this key !',sccol);
        putstring(0,32,'Press any key !',sccol);movp;
        asm mov ax,0; int 16h; mov k,ax;end;
        exit;
      end;
    keys[j]:=k2;
end;

procedure getrot(i:integer);
var j:integer;
begin
   i:=hi(i);
   if i=keys[25] then begin
        rot_y:=rot_y-rotstep;
        if rot_y=-edge_grad then rot_y:=rot_y-rotstep;
        if rot_y<-edge_grad then begin
            rot_y:=rot_y+2*edge_grad;
            rotally(-2*edge_grad,-30,30);
            rotfy(1);
            buildcube;
            addbuff(17);
          end;
       end else
   if i=keys[26] then begin
        rot_y:=rot_y+rotstep;
        if rot_y=edge_grad then rot_y:=rot_y+rotstep;
        if rot_y>edge_grad then begin
            rot_y:=rot_y-2*edge_grad;
            rotally(2*edge_grad,-30,30);
            rotfy(-1);
            buildcube;
            addbuff(16);
          end;
       end else
   if i=keys[24] then begin
     if rot_x>-edge_grad+rotstep then begin
        rot_x:=rot_x-rotstep;
       end end else
   if i=keys[23] then begin
     if rot_x<edge_grad-rotstep then begin
        rot_x:=rot_x+rotstep;
       end end else
   if i=keys[28] then begin
     if rot_z>-edge_grad+rotstep then begin
        rot_z:=rot_z-rotstep;
       end end else
   if i=keys[27] then begin
     if rot_z<edge_grad-rotstep then begin
        rot_z:=rot_z+rotstep;
       end end else
{------------------------}
   if i=keys[20] then randbuff else
   if i=keys[21] then randbuff1 else
   if i=41 then begin
             initpoints;
             time1:=t;
           end;
   if i=64 then redefinekeys else
   if i=65 then keys:=defkeys else
   if i=66 then recordmacro else
   for j:=0 to 19 do
     if i=keys[j] then addjob(j,jcdef)
end;

procedure mousepress;
begin
    mox:=mx;moy:=my;
    if (mx>=216) and (mx<224) and (my>=4) and (my<12) then
      begin
       anti:=1-anti;
      end else
    if (mx>=216) and (mx<224) and (my>=29) and (my<37) then
      begin
       scroll:=1-scroll;
      end else
    if (mx>=204) and (mx<226) and (my>=41) and (my<49) then
      begin
        getrot(60*256);
      end else
    if (mx>=204) and (mx<212) and (my>=4) and (my<36) then
      begin
        contrast:=31-(my-4);
      end else
    if (mx>=192) and (mx<200) then
      mt:=3 else
    if (mb and 1)<>0 then begin
       mb:=mb and 1;
       mt:=1;
      end else
      begin
       mb:=mb and 2;
       mt:=2;
      end;
end;

procedure domousejob;
var i,xx,yy:integer;
begin
    if mico=0 then exit;
    xx:=0;yy:=0;
    for i:=0 to 3 do with rc[planes[selface,i]] do
      begin
        xx:=xx+round(x);
        yy:=yy+round(y);
      end;
    xx:=xx div 4;yy:=yy div 4;
    xx:=(xx+20) div 20;
    yy:=(yy+20) div 20;
    case yy*3+xx of
      0:begin
         if mico=1 then addjob(0,jcdef);
         if mico=5 then addjob(3,jcdef);
         if mico=7 then addjob(6,jcdef);
         if mico=3 then addjob(9,jcdef);
         if mico=6 then addjob(12,jcdef);
         if mico=2 then addjob(13,jcdef);
        end;
      1:begin
         if mico=1 then addjob(1,jcdef);
         if mico=5 then addjob(4,jcdef);
         if mico=7 then addjob(6,jcdef);
         if mico=3 then addjob(9,jcdef);
         if mico=6 then addjob(12,jcdef);
         if mico=4 then addjob(13,jcdef);
        end;
      2:begin
         if mico=1 then addjob(2,jcdef);
         if mico=5 then addjob(5,jcdef);
         if mico=7 then addjob(6,jcdef);
         if mico=3 then addjob(9,jcdef);
         if mico=4 then addjob(13,jcdef);
         if mico=8 then addjob(12,jcdef);
        end;
      3:begin
         if mico=1 then addjob(0,jcdef);
         if mico=5 then addjob(3,jcdef);
         if mico=7 then addjob(7,jcdef);
         if mico=3 then addjob(10,jcdef);
         if mico=4 then addjob(12,jcdef);
         if mico=2 then addjob(13,jcdef);
        end;
      4:begin
         if mico=1 then addjob(14,jcdef);
         if mico=5 then addjob(15,jcdef);
         if mico=7 then addjob(16,jcdef);
         if mico=3 then addjob(17,jcdef);
        end;
      5:begin
         if mico=1 then addjob(2,jcdef);
         if mico=5 then addjob(5,jcdef);
         if mico=7 then addjob(7,jcdef);
         if mico=3 then addjob(10,jcdef);
         if mico=6 then addjob(13,jcdef);
         if mico=8 then addjob(12,jcdef);
        end;
      6:begin
         if mico=1 then addjob(0,jcdef);
         if mico=5 then addjob(3,jcdef);
         if mico=7 then addjob(8,jcdef);
         if mico=3 then addjob(11,jcdef);
         if mico=4 then addjob(12,jcdef);
         if mico=8 then addjob(13,jcdef);
        end;
      7:begin
         if mico=1 then addjob(1,jcdef);
         if mico=5 then addjob(4,jcdef);
         if mico=7 then addjob(8,jcdef);
         if mico=3 then addjob(11,jcdef);
         if mico=2 then addjob(12,jcdef);
         if mico=8 then addjob(13,jcdef);
        end;
      8:begin
         if mico=1 then addjob(2,jcdef);
         if mico=5 then addjob(5,jcdef);
         if mico=7 then addjob(8,jcdef);
         if mico=3 then addjob(11,jcdef);
         if mico=2 then addjob(12,jcdef);
         if mico=6 then addjob(13,jcdef);
        end;
    end;
end;

procedure mouserelease;
begin
    if mt=1 then if selface<>-1 then domousejob;
    mico:=0;mt:=0;
end;

procedure mouseaction1;
var dtx,dty:integer;
    r1,r2:real;
begin
    dtx:=mx-mox;dty:=my-moy;
    r1:=dtx;r2:=dty;
    if (dtx=0) and (dty=0) then mico:=0 else
    if dtx=0 then begin
        if dty<0 then mico:=1 else mico:=5;
      end else
    if dty=0 then begin
        if dtx<0 then mico:=7 else mico:=3;
      end else
    begin
      r1:=abs(r1/dty);
      r2:=abs(r2/dtx);
      if (dtx<0) and (dty<0) then
        begin
          if r2>2 then mico:=1 else
          if r1>2 then mico:=7 else
          mico:=8;
        end else
      if (dtx>0) and (dty<0) then
        begin
          if r2>2 then mico:=1 else
          if r1>2 then mico:=3 else
          mico:=2;
        end else
      if (dtx>0) and (dty>0) then
        begin
          if r2>2 then mico:=5 else
          if r1>2 then mico:=3 else
          mico:=4;
        end else
      if (dtx<0) and (dty>0) then
        begin
          if r2>2 then mico:=5 else
          if r1>2 then mico:=7 else
          mico:=6;
        end;
    end;
end;

procedure mouseaction2;
var dtx,dty:integer;
    r1,r2:real;
begin
    dtx:=mx-mox;dty:=my-moy;
    r1:=dtx;r2:=dty;
    if (dtx=0) and (dty=0) then mico:=0 else
    if dtx=0 then begin
        if dty<0 then mico:=1 else mico:=5;
      end else
    if dty=0 then begin
        if dtx<0 then mico:=7 else mico:=3;
      end else
    begin
      r1:=abs(r1/dty);
      r2:=abs(r2/dtx);
      if (dtx<0) and (dty<0) then
        begin
          if r2>1 then mico:=1 else
          mico:=7;
        end else
      if (dtx>0) and (dty<0) then
        begin
          if r2>1 then mico:=1 else
          mico:=3;
        end else
      if (dtx>0) and (dty>0) then
        begin
          if r2>1 then mico:=5 else
          mico:=3;
        end else
      if (dtx<0) and (dty>0) then
        begin
          if r2>1 then mico:=5 else
          mico:=7;
        end;
    end;
    if mt=2 then if (dtx<>0) and (dty<>0) then
       case mico of
         1:begin
            while (-dty)>msens do
              begin
                dty:=dty+msens;
                moy:=moy-msens;
                getrot(80*256);
              end;
           end;
         7:begin
            while (-dtx)>msens do
              begin
                dtx:=dtx+msens;
                mox:=mox-msens;
                getrot(77*256);
              end;
           end;
         5:begin
            while (dty)>msens do
              begin
                dty:=dty-msens;
                moy:=moy+msens;
                getrot(72*256);
              end;
           end;
         3:begin
            while (dtx)>msens do
              begin
                dtx:=dtx-msens;
                mox:=mox+msens;
                getrot(75*256);
              end;
           end;
       end;
end;

procedure mouseaction3;
var i:integer;
begin
   i:=my div 10;
   rot_z:=i*5-40;
   if rot_z>40 then rot_z:=40;
end;

procedure mousemove;
begin
     mob:=mb;
     if mon=1 then
      if mb<>0 then
       if mx<200 then
       if mt=1 then mouseaction1 else
       if mt=2 then mouseaction2
               else mouseaction3;
     asm
       mov ax,0bh
       int 33h
       add word ptr [mx],cx
       add word ptr [my],dx
       mov ax,3
       int 33h
       mov word ptr [mb],bx
     end;
     if (mx<0) then mx:=0;
     if (my<0) then my:=0;
     if (mx>=320) then mx:=319;
     if (my>=200) then my:=199;
     if mon=0 then exit;
     if (mb<>0) and (mob=0) then mousepress;
{     if mob<>0 then mb:=mb and mob;}
     if (mb=0) and (mob<>0) then mouserelease;
end;

procedure dojob;
begin
  case job of
    0:begin
        rotallx(-rotstep2,-30,-10);
        if jobcount=1 then begin
          end;
    end;
    1:begin
        rotallx(-rotstep2,-10,10);
        if jobcount=1 then begin
          end;
    end;
    2:begin
        rotallx(-rotstep2,10,30);
        if jobcount=1 then begin
          end;
    end;
    3:begin
        rotallx(rotstep2,-30,-10);
        if jobcount=1 then begin
          end;
    end;
    4:begin
        rotallx(rotstep2,-10,10);
        if jobcount=1 then begin
          end;
    end;
    5:begin
        rotallx(rotstep2,10,30);
        if jobcount=1 then begin
          end;
    end;
    6:begin
        rotally(rotstep2,-30,-10);
        if jobcount=1 then begin
          end;
    end;
    7:begin
        rotally(rotstep2,-10,10);
        if jobcount=1 then begin
          end;
    end;
    8:begin
        rotally(rotstep2,10,30);
        if jobcount=1 then begin
          end;
    end;
    9:begin
        rotally(-rotstep2,-30,-10);
        if jobcount=1 then begin
          end;
    end;
    10:begin
        rotally(-rotstep2,-10,10);
        if jobcount=1 then begin
          end;
    end;
    11:begin
        rotally(-rotstep2,10,30);
        if jobcount=1 then begin
          end;
    end;
    12:begin
        rotallz(-rotstep2,-30,-10);
        if jobcount=1 then begin
          end;
    end;
    13:begin
        rotallz(rotstep2,-30,-10);
        if jobcount=1 then begin
          end;
    end;
    14:begin
        rotallx(-rotstep2,-30,30);
    end;
    15:begin
        rotallx(rotstep2,-30,30);
    end;
    16:begin
        rotally(rotstep2,-30,30);
    end;
    17:begin
        rotally(-rotstep2,-30,30);
    end;
    18:begin
        rotallz(-rotstep2,-30,30);
    end;
    19:begin
        rotallz(rotstep2,-30,30);
    end;
    20:begin
        time1:=t;
       end;
    else job:=-1;
  end;
  dec(jobcount);if jobcount=0 then begin job:=-1;roundrc;end;
end;

procedure addprejobs(i:integer);
var s:string;
    l:integer;
begin
  s:=prejobs[i];
  l:=length(s);
  if length(kbuff)+l>255 then write(#7) else
   kbuff:=kbuff+s;
end;

procedure getkbuff;
var b:byte;
begin
   b:=byte(kbuff[1])-97;
   delete(kbuff,1,1);
   addjob(b,jcdef);
end;

procedure put33(x,y,k:integer);
var i,j:integer;
begin
   for i:=0 to 2 do
     for j:=0 to 2 do
       bar(x+j*4,y+i*4,3,3,buff,95+cube[k][i,j]*32);
end;

procedure putcube;
var s:string;
begin
   put33(c_x2+12,c_y2+12,0);
   put33(c_x2   ,c_y2+12,1);
   put33(c_x2+12,c_y2+24,2);
   put33(c_x2+12,c_y2+36,3);
   put33(c_x2+24,c_y2+12,4);
   put33(c_x2+12,c_y2   ,5);
   bar(c_x0,c_y0,8,32-contrast,buff,2);
   zbarp:=(rot_z+40)div 5*10;
   bar(192,zbarp,8,40,buff,2);
   str(rotstep2:2,s);
   putstring(206,42,s,2);
end;

procedure doauto0;
var i,j:integer;
begin
    if cube[0][2,1]=fc[5] then begin
        j:=cube[2][0,1];
        if j=fc[0] then begin
           kbuff:='ielb';
           exit;
          end;
        if j=fc[1] then begin
           kbuff:='reib';
           exit;
          end;
        if j=fc[4] then begin
           kbuff:='qelb';
           exit;
          end;
        if j=fc[3] then begin
           kbuff:='rrieib';
           exit;
          end;
      end;
    if cube[2][0,1]=fc[5] then begin
        j:=cube[0][2,1];
        if j=fc[0] then begin
           kbuff:='nn';
           exit;
        end;
        if j=fc[1] then begin
           kbuff:='rinn';
           exit;
        end;
        if j=fc[4] then begin
           kbuff:='qlnn';
           exit;
        end;
        if j=fc[3] then begin
           kbuff:='qqllnn';
           exit;
        end;
      end;
    if cube[0][0,1]=fc[5] then begin
           kbuff:='nn';
           exit;
        end;
    if (cube[5][2,1]=fc[5]) and (cube[0][0,1]<>fc[0]) then begin
           kbuff:='nn';
           exit;
        end;
    if cube[0][1,0]=fc[5] then begin
        j:=cube[1][1,2];
        if j=fc[1] then begin
           kbuff:='a';
           exit;
        end;
        if j=fc[0] then begin
           kbuff:='gaj';
           exit;
        end;
        if j=fc[4] then begin
           kbuff:='ggajj';
           exit;
        end;
        if j=fc[3] then begin
           kbuff:='jag';
           exit;
        end;
      end;
    if cube[0][1,2]=fc[5] then begin
        j:=cube[4][1,0];
        if j=fc[1] then begin
           kbuff:='jjcgg';
           exit;
        end;
        if j=fc[0] then begin
           kbuff:='jcg';
           exit;
        end;
        if j=fc[4] then begin
           kbuff:='c';
           exit;
        end;
        if j=fc[3] then begin
           kbuff:='gcj';
           exit;
        end;
      end;
    if cube[1][2,1]=fc[5] then begin
           kbuff:='r';
           exit;
       end;
    if cube[4][2,1]=fc[5] then begin
           kbuff:='q';
           exit;
       end;
    if cube[3][2,1]=fc[5] then begin
           kbuff:='rr';
           exit;
       end;
    if cube[2][1,0]=fc[5] then begin
           kbuff:='r';
           exit;
       end;
    if cube[2][1,2]=fc[5] then begin
           kbuff:='q';
           exit;
       end;
    if cube[2][2,1]=fc[5] then begin
           kbuff:='rr';
           exit;
       end;
    if cube[1][1,2]=fc[5] then begin
           kbuff:='r';
           exit;
       end;
    if cube[1][1,0]=fc[5] then begin
           kbuff:='r';
           exit;
       end;
    if cube[4][1,2]=fc[5] then begin
           kbuff:='q';
           exit;
       end;
    if cube[4][1,0]=fc[5] then begin
           kbuff:='q';
           exit;
       end;
    if cube[3][1,2]=fc[5] then begin
           kbuff:='rr';
           exit;
       end;
    if cube[3][1,0]=fc[5] then begin
           kbuff:='rr';
           exit;
       end;
{---------------}
    if cube[0][2,0]=fc[5] then begin
       j:=cube[1][2,2];
       if j=fc[1] then begin
           kbuff:='min';
           exit;
       end;
       if j=fc[0] then begin
           kbuff:='lqmin';
           exit;
       end;
       if j=fc[4] then begin
           kbuff:='llqqmin';
           exit;
       end;
       if j=fc[3] then begin
           kbuff:='irmin';
           exit;
       end;
     end;
    if cube[0][2,2]=fc[5] then begin
       j:=cube[4][2,0];
       if j=fc[1] then begin
           kbuff:='iirrnlm';
           exit;
       end;
       if j=fc[0] then begin
           kbuff:='irnlm';
           exit;
       end;
       if j=fc[4] then begin
           kbuff:='nlm';
           exit;
       end;
       if j=fc[3] then begin
           kbuff:='lqnlm';
           exit;
       end;
     end;
    if cube[0][0,0]=fc[5] then begin
           kbuff:='min';
           exit;
       end;
    if cube[0][0,2]=fc[5] then begin
           kbuff:='nlm';
           exit;
       end;
    if cube[2][0,0]=fc[5] then begin
           kbuff:='mlnldia';
           exit;
       end;
    if cube[2][0,2]=fc[5] then begin
           kbuff:='nimiflc';
           exit;
       end;
    if cube[5][2,0]=fc[5] then
      if cube[0][0,0]<>fc[0] then begin
           kbuff:='dla';
           exit;
       end;
    if cube[5][2,2]=fc[5] then
      if cube[0][0,2]<>fc[0] then begin
           kbuff:='fic';
           exit;
       end;
    kbuff:='r';
end;

procedure doauto5;
begin
  auto:=0;
end;

procedure doauto1;
const t1='ldiaimln';
      t2='iflclnim';
var j:integer;
begin
      j:=cube[0][0,1];
      if j=fc[1] then begin
          kbuff:='k';
          exit;
          end;
      if j=fc[3] then begin
          kbuff:='kk';
          exit;
          end;
      if j=fc[4] then begin
          kbuff:='h';
          exit;
          end;
      if cube[0][2,1]=fc[0] then begin
         j:=cube[2][0,1];
         if j=fc[1] then begin
            kbuff:=t1;
            exit;
         end;
         if j=fc[4] then begin
            kbuff:=t2;
            exit;
         end;
       end;
      if cube[0][2,1]<>fc[2] then
        if cube[2][0,1]<>fc[2] then begin
          j:=cube[0][2,1];
          if j=fc[1] then begin
            kbuff:='ir';
            exit;
          end;
          if j=fc[4] then begin
            kbuff:='lq';
            exit;
          end;
          if j=fc[3] then begin
            kbuff:='iirr';
            exit;
          end;
        end;
      if cube[4][2,1]<>fc[2] then
        if cube[2][1,2]<>fc[2] then begin
            kbuff:='i';
            exit;
        end;
      if cube[1][2,1]<>fc[2] then
        if cube[2][1,0]<>fc[2] then begin
            kbuff:='l';
            exit;
        end;
      if cube[3][2,1]<>fc[2] then
        if cube[2][2,1]<>fc[2] then begin
            kbuff:='ii';
            exit;
        end;
      j:=cube[0][1,0];
      if j<>fc[0] then{
        if cube[1][1,2]<>fc[1] then} begin
            kbuff:=t1;
            exit;
        end;
      j:=cube[0][1,2];
      if j<>fc[0] then{
        if cube[4][1,0]<>fc[4] then} begin
            kbuff:=t2;
            exit;
        end;
      kbuff:='r';
end;

procedure doauto2;
const t='cmfnlnim';
var   b:byte;
begin
    b:=0;
    if cube[2][0,1]=fc[2] then b:=b or 1;
    if cube[2][1,2]=fc[2] then b:=b or 2;
    if cube[2][2,1]=fc[2] then b:=b or 4;
    if cube[2][1,0]=fc[2] then b:=b or 8;
    case b of
      0:begin
          kbuff:=t;
          exit;
        end;
      3:begin
          kbuff:='ll'+t;
          exit;
        end;
      5:begin
          kbuff:=t;
          exit;
        end;
      6:begin
          kbuff:='l'+t;
          exit;
        end;
      9:begin
          kbuff:='i'+t;
          exit;
        end;
      10:begin
          kbuff:=t;
          exit;
        end;
      12:begin
          kbuff:=t;
          exit;
        end;
    end;
end;

procedure doauto31;
const pos:array[0..7,0..1] of byte=((0,0),(0,1),(0,2),(1,2),(2,2),(2,1),(2,0),(1,0));
var i,j,k:integer;
    a,b:word;
begin
    a:=0;for i:=0 to 7 do begin
       a:=a shl 1;
       if cube[2][pos[i,0],pos[i,1]]=fc[2] then
         a:=a or 1;
      end;
    if a=$7d then begin
        if cube[0][2,0]=fc[2] then begin
             kbuff:=tl2;
             exit;
          end else begin
             kbuff:='r'+tl2;
             exit;
          end;
      end;
    if a=$5f then begin
        if cube[0][2,0]=fc[2] then begin
             kbuff:=tl1;
             exit;
          end else begin
             kbuff:='q'+tl2;
             exit;
          end;
      end;
    if a=$f5 then begin
             kbuff:='r';
             exit;
      end;
    if a=$d7 then begin
             kbuff:='q';
             exit;
      end;
    if a=$d5 then begin
        if cube[0][2,2]=fc[2] then begin
             kbuff:=tl2;
             exit;
          end else begin
             kbuff:='r'+tl1;
             exit;
          end;
      end;
    if a=$75 then begin
        if cube[0][2,0]=fc[2] then begin
             kbuff:=tl1;
             exit;
          end else begin
             kbuff:='q'+tl2;
             exit;
          end;
      end;
    if a=$57 then begin
             kbuff:='r';
             exit;
      end;
    if a=$5d then begin
             kbuff:='q';
             exit;
      end;
    if a=$55 then begin {}
        if cube[0][2,0]=fc[2] then begin
           if cube[0][2,2]<>fc[2] then begin
               kbuff:=tl2;
               exit;
             end;
           if cube[3][2,2]=fc[2] then begin
               kbuff:='q'+tl2;
               exit;
             end;
          end;
             kbuff:='q';
             exit;
      end;
    if a=$dd then begin
        if cube[0][2,2]=fc[2] then begin
             kbuff:=tl1;
             exit;
          end else begin
             kbuff:='q';
             exit;
          end;
      end;
    if a=$77 then begin
        if cube[0][2,0]=fc[2] then begin
             kbuff:=tl2;
             exit;
          end else begin
             kbuff:='q';
             exit;
          end;
      end;

end;

function done1:boolean;
var ret:boolean;
    i:integer;
begin
    ret:=true;
    for i:=0 to 3 do
      if cube[lat[i]][2,0]<>cube[lat[i]][2,2] then
        ret:=false;
    done1:=ret;
end;

procedure doauto321;
var i:integer;
begin
   i:=abs(cube[0][2,1]-cube[3][2,1]);
   if i=3 then begin
     kbuff:=tl2+'q'+tl1;
     exit;
   end;
   i:=(cube[3][2,1]+3) mod 6;
   if i=cube[1][2,1] then begin
     kbuff:=tl1+'r'+tl2;
     exit;
   end else begin
     kbuff:=tl2+'q'+tl1;
     exit;
   end;
end;

function getcpos(i:integer):integer;
var p,k:integer;
begin
    for k:=0 to 3 do
      if fc[lat[k]]=i then p:=k;
    getcpos:=p;
end;

procedure rotar;
var i,t:integer;
begin
    t:=ar[0];for i:=0 to 2 do ar[i]:=ar[i+1];ar[3]:=t;
end;

procedure doauto32;
const tt1=tl1+'r'+tl2;
      tt2=tl2+'q'+tl1;
var i,j,k:integer;
begin
   i:=abs(ar[2]-ar[0]);
   if i=2 then begin
     kbuff:=tl2+'q'+tl1;
     exit;
   end;
   kbuff:='';
   while ar[0]<>0 do begin
       rotar;
       kbuff:=kbuff+'q';
    end;
   if length(kbuff)=3 then kbuff:='r';
   if ar[1]=1 then begin
       kbuff:=kbuff+'q'+tt1;
       exit;
     end;
   if ar[1]=3 then begin
       kbuff:=kbuff+'qq'+tt2;
       exit;
     end;
   if ar[2]=1 then begin
       kbuff:=kbuff+tt1;
       exit;
     end;
   if ar[2]=3 then begin
       kbuff:=kbuff+'qq'+tt1;
       exit;
     end;
end;

function done2:boolean;
var i,j:integer;
begin
    done2:=false;
    if ar[2]=2 then begin
       if ar[1]=1 then begin
         done2:=true;
         exit;
       end else begin
         kbuff:=tl1+'r'+tl2;
         exit;
       end;
    end;
    doauto32;
end;

procedure doauto33;
var i,j:integer;
begin
    j:=-1;
    for i:=0 to 3 do
      if cube[lat[i]][2,0]=fc[lat[i]] then
         j:=i;
    if j=1 then begin
         kbuff:='q';
         exit;
      end;
    if j=2 then begin
         kbuff:='qq';
         exit;
      end;
    if j=3 then begin
         kbuff:='r';
         exit;
      end;
    if cube[1][2,0]=fc[4] then begin
         kbuff:=h2+tl2;
         exit;
      end else begin
         kbuff:='r'+h1+tl1;
         exit;
      end;
end;

procedure doauto3;
var i,j,k:integer;
begin
   k:=0;for i:=0 to 2 do for j:=0 to 2 do if cube[2][i,j]=fc[2] then inc(k);
   if k<>9 then begin
       doauto31;
       exit;
     end;
   for i:=0 to 3 do ar[i]:=getcpos(cube[lat[i]][2,1]);
   if done1 then begin
       if cube[1][2,2]=fc[0] then begin
           kbuff:='l';
           exit;
        end;
       if cube[4][2,2]=fc[0] then begin
           kbuff:='i';
           exit;
        end;
       if cube[3][2,2]=fc[0] then begin
           kbuff:='ll';
           exit;
        end;
       if cube[0][2,1]=fc[0] then begin
           kbuff:='rr';
           exit;
        end;
       if cube[1][2,1]=fc[1] then begin
           kbuff:='q';
           exit;
        end;
       if cube[4][2,1]=fc[4] then begin
           kbuff:='r';
           exit;
        end;
       doauto321;
       exit;
     end;
   if ar[1]=0 then begin
      kbuff:='i';
      exit;
     end;
   if ar[2]=0 then begin
      kbuff:='ii';
      exit;
     end;
   if ar[3]=0 then begin
      kbuff:='l';
      exit;
     end;
   if done2 then begin
        j:=cube[0][2,1];
        if j=fc[1] then begin
           kbuff:='i';
           exit;
          end;
        if j=fc[3] then begin
           kbuff:='ii';
           exit;
          end;
        if j=fc[4] then begin
           kbuff:='l';
           exit;
          end;
        doauto33;
     end;
end;

procedure doauto;
begin
   if lst=0 then doauto0;
   if lst=1 then doauto1;
   if lst=2 then doauto2;
   if (lst>=3) and (lst<=4)
            then doauto3;
   if lst=5 then doauto5;
end;

procedure doit;
var i,j,st:integer;
begin
    clr2;lst:=0;
    repeat
     inc(fcnt);
     if job=-1 then mon:=1 else mon:=0;mousemove;
     point3:=rc;rotate;proj;
     clr2;
     plonr:=0;
     if mico=0 then selface:=-1;
     for i:=0 to plnr-1 do makeplane(i);
     for i:=plonr-1 downto 0 do drawplane(i);
     putcube;puttime(c_x1,c_y1);puttime2(c_x1,c_y1+11,timel);
     if scroll=1 then puttxtline;
     if anti=1 then putchar(217,4,byte('A'),15)
               else putchar(217,4,byte('A'),8);
     if scroll=1 then putchar(217,29,byte('S'),15)
                else putchar(217,29,byte('S'),8);
     if recording=1 then
      if (((fcnt and 8)=0) and (recordfull=0)) then
       putstring(0,192,'RECORDING...',4) else
      if (((fcnt and 4)=0) and (recordfull=1)) then
       putstring(0,192,'The buffer is full !!!',4);
     if auto=1 then if (fcnt and 8)=0then
       putstring(168,192,'Auto',timecolc);
     st:=getcubestat;if st=5 then j:=timecolc else j:=4;
     if st>0 then for i:=0 to st-1 do
       bar(c_x4+i*12,c_y4,10,2,buff,j);
     if lst<>5 then if st=5 then begin
       timel:=time2;
       time1:=t;
       end;
     lst:=st;
     if wvron=1 then wwr;
     putm(mx,my,mico);movp;
     if auto=1 then if (job=-1) and (byte(kbuff[0])=0)
       then doauto;
     i:=0;
     if job<>-1 then dojob;
     if keypressed then
       begin
         asm
           xor ax,ax
           int 16h
           mov i,ax
         end;
         if hi(i)=63 then scroll:=1-scroll;
         if hi(i)=67 then wvron:=1-wvron;
         if hi(i)=68 then begin auto:=1-auto;kbuff[0]:=#0;time1:=t;end;
         if hi(i)=78 then if zoom<=1.9 then zoom:=zoom+0.1;
         if hi(i)=74 then if zoom>=1 then zoom:=zoom-0.1;
         if hi(i)=76 then begin rot_x:=15;rot_y:=-15;rot_z:=0;end;
         if hi(i)=59 then anti:=1-anti;
         if hi(i)=61 then if contrast>1 then dec(contrast);
         if hi(i)=62 then if contrast<32 then inc(contrast);
         if HI(i)=60 then if job=-1 then begin
              rot:=(rot+1) mod rotcmax;
              rotstep2:=rotconst[rot,0];
              jcdef:=rotconst[rot,1];
           end;
         if auto=0 then begin
             if hi(i)=keys[22] then kbuff:=starttime;
             if job=-1 then begin
               if (hi(i)>=2) and (hi(i)<=11) then addprejobs(hi(i)-2);
               if byte(kbuff[0])=0 then getrot(i);
             end;
         end;
       end else
     if job=-1 then
     if byte(kbuff[0])>0 then
       getkbuff;
    until hi(i)=1;
end;

var x,y,c:t4;
    t1,t2:longint;
    r:real;
    i:integer;

    f:file;

begin
    init;
    kbuff:='';
    zoom:=2;
    t1:=t;time1:=t;
    doit;
    t2:=t;
    done;
    writeln(fcnt*18.2/(t2-t1):10:3,' fps');
end.